;*********************************
;*  Viewer hxadcimal pour Ti89 *
;*  Version 1.5                  *
;*********************************
;Lurdos Olivier
;OLURDOS@Wanadoo.fr

	include "Doorsos.h"
	include "Util.h"
	include "GraphLib.h"
	include "UserLib.h"
	xdef _ti89
	xdef _main
	xdef _comment

;***********
;*  Macro  *
;***********
DispChar	Macro
	;DispChar x,y,cde
	;affiche le caracre cde  la position (x,y)
	move.w	#4,-(a7)	;couleur
	move.w	\2,-(a7)	;y
	move.w	\1,-(a7)	;x
	move.w	\3,-(a7)	;code
	jsr	util::DrawCharXY
	lea	8(a7),a7
	EndM

DispStr		Macro
	;DispStr str
	;affiche la chaine str  la position x,y
	pea	\1(pc)
	bsr	DrawStr
	EndM


;********************
;*  Sous-programme  *
;********************
DrawStr:
	;input : (par la pile) adresse de la chaine de caractres
	;ex:	pea	string(pc)
	;	bsr	DrawStr
	;Affiche la chaine  la position x,y
	move.l		(a7)+,a6
	move.l		(a7)+,a0
	WriteStrA	x,y,#4,a0
	move.w		#0,x
	add		#10,y
	move.l		a6,-(a7)
	rts

AffichHex:
	;input	d0.b = nb  afficher
	;affiche le nombre au format hxadcimal  la position (x,y)
	clr.l		d1
	move.b		d0,d1
	clr.l		d0
	move.b		d1,d0
	divu		#16,d0		;1symbole d0=d0/16
	move.l		d0,-(a7)
	bsr		GetCode
	DispChar	x,y,d0
	add		#6,x
	move.w		#16,d1		;2symbole reste de la division d0/16
	move.l		(a7)+,d0	;(contenu dans les 2 premiers bits de d0)
	rol.l		d1,d0
	bsr		GetCode
	DispChar	x,y,d0
	add		#6,x
	rts

GetCode:
	;input	d0.b = code hex
	;output	d0.w = code du caractre correspondant
	clr	d1
	move.b	d0,d1
	sub	#10,d1
	bge	\lettre
	clr	d1
	move.b	d0,d1
	add	#48,d1
	move.w	d1,d0
	rts
	\lettre:
	add.b	#65,d1
	move.w	d1,d0
	rts

AffichHex2:
	;input	d0.l = nb  afficher
	;affiche le nombre au format hxadcimal  la position (x,y)
	move.l	d0,-(a7)
	move.w	#3,d7
	\AffHex2Loop:
	move.w	#8,d1
	move.l	(a7)+,d0
	rol.l	d1,d0
	move.l	d0,-(a7)
	and.l	#$FF,d0
	bsr	AffichHex
	dbeq	d7,\AffHex2Loop
	move.l	(a7)+,d0
	rts

InputHex:
	;input = nothing
	;Output	d0.l = Nb hxa que l'utilisateur  entrer
	;       d1.w = 0 si l'utilisateur  appuyer sur entrer
	;	       1         "       "       "      ESC
	;L'utilisateur entre un nombre au format Hex  la position x,y
		;userlib::InputStr
		;    d1.w : X
		;    d2.w : Y
		;    d3.w : Maxchar
		;output:  d0 = nbchars or 0 if no char pressed/ESC pressed
		;	  a0 = adress of the string

	move.w	x,d1
	move.w	y,d2
	move.w	#8,d3
	jsr	userlib::InputStr
	move.l	a0,adr2
	move.w	d0,d7
	sub.l	#1,d7
	move.l	#0,adr3

	\loop:
	move.w	#4,d0	adr3=adr3*16
	move.l	adr3,d1
	rol.l	d0,d1
	move.l	d1,adr3

	clr.l	d0
	move.l	adr2,a0
	move.b	(a0),d0
	bsr	GetCodeHex
	add.l	d0,adr3
	add.l	#1,adr2
	dbeq	d7,\loop

	move.l	adr3,adr
	rts

GetCodeHex:
	;input	d0.b=code de la touche
	;output	d0.b=code hxa. correspondant
	;	"0" <=> 0
	;	"1" <=> 1
	;	    ...
	;	"A" <=> 10
	;	"F" <=> 15
	;	"a" <=> 10
	;	"f" <=> 15
	move.b	d0,d5

	move.w	#10,d2		;Recherche les nombres
	move.b	#48,d1
	\GchLoopNb:
	cmp.b	d5,d1
	beq	\GchNb
	add.b	#1,d1
	sub	#1,d2
	bne	\GchLoopNb

	move.w	#6,d2		;Recherche les lettres minuscules
	move.b	#97,d1
	\GchLoopLettreMin:
	cmp.b	d5,d1
	beq	\GchLettreMin
	add.b	#1,d1
	sub	#1,d2
	bne	\GchLoopLettreMin

	move.w	#6,d2		;Recherche les lettres majuscules
	move.b	#65,d1
	\GchLoopLettreMaj:
	cmp.b	d5,d1
	beq	\GchLettreMaj
	add.b	#1,d1
	sub	#1,d2
	bne	\GchLoopLettreMaj

	clr.l	d0		;rien trouv
	rts

	\GchNb:			;nombre trouv
	clr.l	d0
	sub	#48,d5
	move.b	d5,d0
	rts
	\GchLettreMin:		;lettre min. trouve
	clr.l	d0
	sub	#87,d5
	move.b	d5,d0
	rts
	\GchLettreMaj:		;lettre maj. trouve
	clr.l	d0
	sub	#55,d5
	move.b	d5,d0
	rts

;**********
;*  Main  *
;**********
_main:
	move.l	#0,adr
deb:
	jsr		util::zap_screen
	WriteStr	#0,#0,#4,StrAdr		;affiche "Addresse:"
	move.w		#0,-(a7)		;change la font
	jsr		doorsos::FontSetSys
	WriteStr	#10,#92,#4,StrAide	;affiche "Aide : [F1]"
	move.w		#1,-(a7)
	jsr		doorsos::FontSetSys
	lea		4(a7),a7

	move.w	#111,d0		;ligne verticale
	move.w	#8,d1
	move.w	#90,d2
	jsr	graphlib::vert
	move.w	#0,d0	;x1	ligne horizontale (haut)
	move.w	#8,d1	;y
	move.w	#160,d2	;x2
	move.w	#2,d3	;couleur
	jsr	graphlib::horiz
	move.w	#90,d1		;ligne horizontale (bas)
	jsr	graphlib::horiz

	move.w	#0,y		;affichage de l'adresse
	move.w	#60,x
	move.l	adr,d0
	bsr	AffichHex2

	move.w	#10,y
	move.w	#8,l	;compteur ligne = 8
	move.l	adr,adr2

	\ligne:				;dbut boucle ligne
	move.w	#0,x
	move.l	adr2,adr3
	move.w	#8,c
	\AffHex:			;dbut boucle CodeHex
	clr.l		d0		;(Affichage des codes hex)
	move.l		adr3,a0
	move.b		(a0),d0
	bsr		AffichHex
	add		#2,x
	add.l		#1,adr3
	sub		#1,c		;fin boucle hex
	bne		\AffHex

	move.l	adr2,adr3
	move.w	#8,c
	\caractere:			;dbut boucle Caractre
	clr.l		d0		;(Affichage des caractres)
	move.l		adr3,a0
	move.b		(a0),d0
	DispChar	x,y,d0
	add		#6,x
	add.l		#1,adr3
	sub		#1,c		;fin boucle caractere
	bne		\caractere

	add	#10,y
	add.l	#8,adr2
	sub	#1,l			;fin boucle ligne
	bne	\ligne

	jsr	util::idle_loop
	cmp	#268,d0		;code F1 = Aide
	beq	f1
	cmp	#269,d0		;code F2
	beq	f2
	cmp	#270,d0		;code F3 ;chercher
	beq	f3
	cmp	#271,d0		;code F4 ;chercher encore
	beq	f4
	cmp	#272,d0		;code F5 ;about
	beq	f5
	cmp	#340,d0		;code bas
	beq	bas
	cmp	#4436,d0	;code shift+bas
	beq	shbas
	cmp	#16724,d0	;code diamond+bas
	beq	dmbas
	cmp	#337,d0		;code haut
	beq	haut
	cmp	#4433,d0	;code shift+haut
	beq	shhaut
	cmp	#16721,d0	;code diamond+haut
	beq	dmhaut
	cmp	#264,d0		;code ESC => Fin
	beq	fin
	bra	deb
fin:	rts

haut:	sub.l	#$10,adr
	bra	deb
shhaut:	sub.l	#$40,adr
	bra	deb
dmhaut:	sub.l	#$1000,adr
	bra	deb
bas:	add.l	#$10,adr
	bra	deb
shbas:	add.l	#$40,adr
	bra	deb
dmbas:	add.l	#$1000,adr
	bra	deb

;******************************************
f1:
	jsr	util::zap_screen
	move.w	#0,x
	move.w	#0,y
	DispStr	id1
	DispStr	id2
	add	#42,x
	DispStr	id3
	DispStr	id4
	DispStr	id5
	DispStr	id6
	add	#6,x
	DispStr	id7
	jsr	util::idle_loop
	bra	deb

;******************************************
f2:
	jsr		util::zap_screen
	move.w	#0,x
	move.w	#10,y
	DispStr	StrHex
	DispStr	StrHex2

	move.w	#35,y
	move.w	#10,x
	bsr	InputHex
	move.l	d0,adr2
	cmp	#0,d1
	beq	\f2OK
	bra	deb
	\f2OK:
	move.l	adr2,adr
	bra	deb

;******************************************
f3:
	jsr	util::zap_screen
	move.w	#0,x
	move.w	#10,y
	DispStr	sc1
	DispStr	sc2

	move.w	#35,y
	move.w	#10,x
	bsr	InputHex
	clr.l	adr2
	move.l	d0,adr2
	cmp	#0,d1
	beq	\f3OK
	bra	deb
	\f3OK:
	move.l	adr2,d0
	move.b	d0,search
	move.l	adr,a6

sch:				;boucle "search"
	move.b	(a6)+,d0
	cmp.b	search,d0
	beq	\find
	bra	sch

	\find:
	sub.l	#1,a6
	move.l	a6,adr
	bra	deb


;******************************************
f4:
	jsr	util::zap_screen
	move.l	adr,a6	;on ajoute 1  l'adresse
	add.l	#1,a6
	bra	sch	;puis on continue la recherche

;******************************************
f5:
	jsr	util::zap_screen
	move.w	#0,x
	move.w	#0,y
	DispStr	ab1
	add	#10,y
	DispStr	ab2
	add	#10,y
	DispStr	ab3
	DispStr	ab4
	jsr	util::idle_loop
	bra	deb


;***************
;*  Variables  *
;***************
_comment:
	dc.b	"Viewer hwadcimal - Version 1.5"

adr	dc.l	0
adr2	dc.l	0
adr3	dc.l	0

x	dc.w	0
y	dc.w	0

l	dc.w	0		;compteur ligne
c	dc.w	0		;compteur colonne

search	dc.b	0

StrAdr	dc.b	"Adresse :",0
StrAide	dc.b	"Aide = [F1]  -  Quitter = ESC",0

id1	dc.b	"[F1] = Aide",0			;Ecran d'aide
id2	dc.b	"[F2] = Aller  une",0
id3	dc.b	"nouvelle addresse",0
id4	dc.b	"[F3] = Rechercher",0
id5	dc.b	"[F4] = Chercher encore",0
id6	dc.b	"[F5] = About",0
id7	dc.b	"ESC = Quitter",0

StrHex	dc.b	"Entrez l'adresse",0		;Ecran nouvelle adresse
StrHex2	dc.b	"hexadcimale :",0

sc1	dc.b	"Entrez le code hxadcimal",0	;Ecran Chercher
sc2	dc.b	"a chercher :",0

ab1	dc.b	"HxView89 - Version 1.5",0	;Ecran About
ab2	dc.b	"Lurdos Olivier",0
ab3	dc.b	"En cas de bugs :",0
ab4	dc.b	"OLURDOS@Wanadoo.fr",0
	end